'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cleanReactProps = require('clean-react-props');

var _cleanReactProps2 = _interopRequireDefault(_cleanReactProps);

var _reactIndicators = require('react-indicators');

var _pagingIndicator = require('./pagingIndicator');

var _pagingIndicator2 = _interopRequireDefault(_pagingIndicator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BarsIndicator = function (_Component) {
  _inherits(BarsIndicator, _Component);

  function BarsIndicator() {
    _classCallCheck(this, BarsIndicator);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  BarsIndicator.prototype.render = function render() {
    var _props = this.props,
        backgroundColor = _props.backgroundColor,
        children = _props.children,
        color = _props.color,
        height = _props.height,
        index = _props.index,
        length = _props.length,
        onIndicatorClick = _props.onIndicatorClick,
        progress = _props.progress,
        randomKey = _props.randomKey,
        renderIndicators = _props.renderIndicators,
        width = _props.width;


    var indicator = _react2.default.createElement(_reactIndicators.BarIndicator, {
      backgroundColor: backgroundColor,
      color: color,
      height: height,
      width: width
    });

    return _react2.default.createElement(
      'div',
      (0, _cleanReactProps2.default)(this.props),
      renderIndicators({
        indicator: indicator,
        index: index,
        keyPrefix: randomKey,
        length: length,
        onIndicatorClick: onIndicatorClick,
        progress: progress
      }),
      children
    );
  };

  return BarsIndicator;
}(_react.Component);

BarsIndicator.propTypes = {
  backgroundColor: _propTypes2.default.string,
  color: _propTypes2.default.string,
  height: _propTypes2.default.number,
  width: _propTypes2.default.number,
  renderIndicators: _propTypes2.default.func
};

BarsIndicator.defaultProps = {
  backgroundColor: '#ccc',
  color: 'black',
  height: 5,
  width: 45,
  renderIndicators: function renderIndicators() {}
};

exports.default = (0, _pagingIndicator2.default)(BarsIndicator);