'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cleanReactProps = require('clean-react-props');

var _cleanReactProps2 = _interopRequireDefault(_cleanReactProps);

var _reactIndicators = require('react-indicators');

var _pagingIndicator = require('./pagingIndicator');

var _pagingIndicator2 = _interopRequireDefault(_pagingIndicator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DotsIndicator = function (_Component) {
  _inherits(DotsIndicator, _Component);

  function DotsIndicator() {
    _classCallCheck(this, DotsIndicator);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  DotsIndicator.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        fill = _props.fill,
        fillBackground = _props.fillBackground,
        index = _props.index,
        indicatorClassName = _props.indicatorClassName,
        length = _props.length,
        onIndicatorClick = _props.onIndicatorClick,
        progress = _props.progress,
        randomKey = _props.randomKey,
        renderIndicators = _props.renderIndicators,
        size = _props.size,
        stroke = _props.stroke,
        strokeBackground = _props.strokeBackground,
        strokeWidth = _props.strokeWidth;


    var indicator = _react2.default.createElement(_reactIndicators.CircleIndicator, {
      className: indicatorClassName,
      fill: fill,
      fillBackground: fillBackground,
      size: size,
      stroke: stroke,
      strokeBackground: strokeBackground,
      strokeWidth: strokeWidth
    });

    return _react2.default.createElement(
      'div',
      (0, _cleanReactProps2.default)(this.props),
      renderIndicators({
        indicator: indicator,
        index: index,
        length: length,
        progress: progress,
        keyPrefix: randomKey,
        onIndicatorClick: onIndicatorClick
      }),
      children
    );
  };

  return DotsIndicator;
}(_react.Component);

DotsIndicator.propTypes = {
  fill: _propTypes2.default.string,
  fillBackground: _propTypes2.default.string,
  indicatorClassName: _propTypes2.default.string,
  length: _propTypes2.default.number,
  renderIndicators: _propTypes2.default.func,
  size: _propTypes2.default.number,
  stroke: _propTypes2.default.string,
  strokeBackground: _propTypes2.default.string,
  strokeWidth: _propTypes2.default.number
};

DotsIndicator.defaultProps = {
  fill: '#000',
  fillBackground: '#ccc',
  index: 0,
  length: 1,
  renderIndicators: function renderIndicators() {},
  size: 10,
  stroke: 'transparent',
  strokeBackground: 'transparent',
  strokeWidth: 0
};

exports.default = (0, _pagingIndicator2.default)(DotsIndicator);