function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cleanProps from 'clean-react-props';
import { BarIndicator } from 'react-indicators';
import pagingIndicator from './pagingIndicator';

var BarsIndicator = function (_Component) {
  _inherits(BarsIndicator, _Component);

  function BarsIndicator() {
    _classCallCheck(this, BarsIndicator);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  BarsIndicator.prototype.render = function render() {
    var _props = this.props,
        backgroundColor = _props.backgroundColor,
        children = _props.children,
        color = _props.color,
        height = _props.height,
        index = _props.index,
        length = _props.length,
        onIndicatorClick = _props.onIndicatorClick,
        progress = _props.progress,
        randomKey = _props.randomKey,
        renderIndicators = _props.renderIndicators,
        width = _props.width;


    var indicator = React.createElement(BarIndicator, {
      backgroundColor: backgroundColor,
      color: color,
      height: height,
      width: width
    });

    return React.createElement(
      'div',
      cleanProps(this.props),
      renderIndicators({
        indicator: indicator,
        index: index,
        keyPrefix: randomKey,
        length: length,
        onIndicatorClick: onIndicatorClick,
        progress: progress
      }),
      children
    );
  };

  return BarsIndicator;
}(Component);

BarsIndicator.propTypes = {
  backgroundColor: PropTypes.string,
  color: PropTypes.string,
  height: PropTypes.number,
  width: PropTypes.number,
  renderIndicators: PropTypes.func
};

BarsIndicator.defaultProps = {
  backgroundColor: '#ccc',
  color: 'black',
  height: 5,
  width: 45,
  renderIndicators: function renderIndicators() {}
};

export default pagingIndicator(BarsIndicator);