function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cleanProps from 'clean-react-props';
import pagingIndicator from './pagingIndicator';

var CustomIndicator = function (_Component) {
  _inherits(CustomIndicator, _Component);

  function CustomIndicator() {
    _classCallCheck(this, CustomIndicator);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  CustomIndicator.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        indicator = _props.indicator,
        index = _props.index,
        length = _props.length,
        onIndicatorClick = _props.onIndicatorClick,
        progress = _props.progress,
        randomKey = _props.randomKey,
        renderIndicators = _props.renderIndicators;


    return React.createElement(
      'div',
      cleanProps(this.props),
      renderIndicators({
        indicator: indicator,
        index: index,
        length: length,
        onIndicatorClick: onIndicatorClick,
        progress: progress,
        keyPrefix: randomKey
      }),
      children
    );
  };

  return CustomIndicator;
}(Component);

CustomIndicator.propTypes = {
  index: PropTypes.number,
  indicator: PropTypes.element,
  length: PropTypes.number,
  progress: PropTypes.number,
  renderIndicators: PropTypes.func
};

CustomIndicator.defaultProps = {
  index: 0,
  length: 1,
  progress: 1,
  renderIndicators: function renderIndicators() {}
};

export default pagingIndicator(CustomIndicator);