function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cleanProps from 'clean-react-props';
import { CircleIndicator } from 'react-indicators';
import pagingIndicator from './pagingIndicator';

var DotsIndicator = function (_Component) {
  _inherits(DotsIndicator, _Component);

  function DotsIndicator() {
    _classCallCheck(this, DotsIndicator);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  DotsIndicator.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        fill = _props.fill,
        fillBackground = _props.fillBackground,
        index = _props.index,
        indicatorClassName = _props.indicatorClassName,
        length = _props.length,
        onIndicatorClick = _props.onIndicatorClick,
        progress = _props.progress,
        randomKey = _props.randomKey,
        renderIndicators = _props.renderIndicators,
        size = _props.size,
        stroke = _props.stroke,
        strokeBackground = _props.strokeBackground,
        strokeWidth = _props.strokeWidth;


    var indicator = React.createElement(CircleIndicator, {
      className: indicatorClassName,
      fill: fill,
      fillBackground: fillBackground,
      size: size,
      stroke: stroke,
      strokeBackground: strokeBackground,
      strokeWidth: strokeWidth
    });

    return React.createElement(
      'div',
      cleanProps(this.props),
      renderIndicators({
        indicator: indicator,
        index: index,
        length: length,
        progress: progress,
        keyPrefix: randomKey,
        onIndicatorClick: onIndicatorClick
      }),
      children
    );
  };

  return DotsIndicator;
}(Component);

DotsIndicator.propTypes = {
  fill: PropTypes.string,
  fillBackground: PropTypes.string,
  indicatorClassName: PropTypes.string,
  length: PropTypes.number,
  renderIndicators: PropTypes.func,
  size: PropTypes.number,
  stroke: PropTypes.string,
  strokeBackground: PropTypes.string,
  strokeWidth: PropTypes.number
};

DotsIndicator.defaultProps = {
  fill: '#000',
  fillBackground: '#ccc',
  index: 0,
  length: 1,
  renderIndicators: function renderIndicators() {},
  size: 10,
  stroke: 'transparent',
  strokeBackground: 'transparent',
  strokeWidth: 0
};

export default pagingIndicator(DotsIndicator);