'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lomit = require('lomit');

var _lomit2 = _interopRequireDefault(_lomit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var renderIndicators = function renderIndicators(_ref) {
  var indicator = _ref.indicator,
      _ref$index = _ref.index,
      index = _ref$index === undefined ? 0 : _ref$index,
      _ref$keyPrefix = _ref.keyPrefix,
      keyPrefix = _ref$keyPrefix === undefined ? 'paging-indicator-' : _ref$keyPrefix,
      _ref$length = _ref.length,
      length = _ref$length === undefined ? 0 : _ref$length,
      _ref$onIndicatorClick = _ref.onIndicatorClick,
      onIndicatorClick = _ref$onIndicatorClick === undefined ? function () {} : _ref$onIndicatorClick,
      _ref$progress = _ref.progress,
      progress = _ref$progress === undefined ? 1 : _ref$progress;

  var indicators = [];

  if (!indicator) {
    return indicators;
  }

  for (var i = 0; i < length; i++) {
    indicators.push(_react2.default.cloneElement(indicator, {
      key: keyPrefix + '-item-' + i,
      progress: i === index ? progress : 0,
      onClick: onIndicatorClick.bind(this, i)
    }));
  }

  return indicators;
};

var pagingIndicator = function pagingIndicator(IndicatorComponent) {
  return function (_PureComponent) {
    _inherits(_class, _PureComponent);

    function _class(props) {
      _classCallCheck(this, _class);

      var _this = _possibleConstructorReturn(this, _PureComponent.call(this, props));

      _this.state = {
        index: props.index,
        progress: 1,
        randomKey: 'indicator-pager-' + Math.round(Date.now() * Math.random()),
        timerDisabled: false
      };

      _this.boundRenderIndicators = renderIndicators.bind(_this);
      _this.onTimerTimeUpdate = _this.onTimerTimeUpdate.bind(_this);
      _this.onTimerFinish = _this.onTimerFinish.bind(_this);
      return _this;
    }

    _class.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      var index = nextProps.index;


      if (index !== this.props.index) {
        this.setState({
          index: index
        });
      }
    };

    _class.prototype.onIndicatorClick = function onIndicatorClick(index) {
      var _this2 = this;

      this.setState({
        progress: 1,
        timerDisabled: true,
        index: index
      });

      if (this.props.onChange) {
        this.props.onChange(index);
      }

      if (this.props.timer) {
        clearTimeout(this.timerTimeout);
        this.timerTimeout = setTimeout(function () {
          _this2.setState({
            progress: 0,
            timerDisabled: false
          });
        }, 10000);
      }
    };

    _class.prototype.onTimerTimeUpdate = function onTimerTimeUpdate(_ref2) {
      var duration = _ref2.duration,
          progress = _ref2.progress,
          time = _ref2.time;

      this.setState({
        progress: progress
      });
    };

    _class.prototype.onTimerFinish = function onTimerFinish() {
      var length = this.props.length;


      var nextIndex = this.state.index + 1;
      if (typeof length !== 'undefined' && nextIndex === length) {
        nextIndex = 0;
      }

      this.setState({
        index: nextIndex
      });

      if (this.props.onChange) {
        this.props.onChange(nextIndex);
      }
    };

    _class.prototype.render = function render() {
      var _props = this.props,
          children = _props.children,
          timer = _props.timer;
      var timerDisabled = this.state.timerDisabled;


      var clonedTimer = timer && !timerDisabled ? _react2.default.cloneElement(timer, {
        onFinish: this.onTimerFinish,
        onTimeUpdate: this.onTimerTimeUpdate
      }) : null;

      return _react2.default.createElement(
        IndicatorComponent,
        _extends({}, (0, _lomit2.default)(this.props, ['index']), this.state, {
          renderIndicators: this.props.hasOwnProperty('renderIndicators') ? this.props.renderIndicators : this.boundRenderIndicators,
          onIndicatorClick: this.onIndicatorClick
        }),
        children,
        clonedTimer
      );
    };

    return _class;
  }(_react.PureComponent);
};

exports.default = pagingIndicator;